use std::{io, error::Error};

use tinkerforge::{ip_connection::IpConnection,
                  color_bricklet::*};


const HOST: &str = "localhost";
const PORT: u16 = 4223;
const UID: &str = "XYZ"; // Change XYZ to the UID of your Color Bricklet.

fn main() -> Result<(), Box<dyn Error>> {
    let ipcon = IpConnection::new(); // Create IP connection.
    let c = ColorBricklet::new(UID, &ipcon); // Create device object.

    ipcon.connect((HOST, PORT)).recv()??; // Connect to brickd.
    // Don't use device before ipcon is connected.

		// Get current color.
let color = c.get_color().recv()?;

		println!("Color [R]: {}", color.r);
		println!("Color [G]: {}", color.g);
		println!("Color [B]: {}", color.b);
		println!("Color [C]: {}", color.c);

    println!("Press enter to exit.");
    let mut _input = String::new();
    io::stdin().read_line(&mut _input)?;
    ipcon.disconnect();
    Ok(())
}
